Index: palm/trunk/SCRIPTS/.palm.iofiles
===================================================================
--- palm/trunk/SCRIPTS/.palm.iofiles	(revision 3703)
+++ palm/trunk/SCRIPTS/.palm.iofiles	(revision 3704)
@@ -60,4 +60,6 @@
 SURFACE_DATA_AV_BIN*       out:tr   *         $base_data/$run_identifier/OUTPUT         _av_surf   bin
 #
+VIRTUAL_MEAS_BIN*          out   *            $base_data_output/$run_identifier/OUTPUT  _vmeas     bin
+#
 DATA_1D_PR_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _pr        nc
 DATA_1D_SP_NETCDF*         out:tr   *         $base_data/$run_identifier/OUTPUT         _sp        nc
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 3703)
+++ palm/trunk/SOURCE/check_open.f90	(revision 3704)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Open binary files for virtual measurements
 ! 
 ! Former revisions:
@@ -470,5 +470,10 @@
           OPEN ( 26, FILE='SURFACE_DATA_AV_BIN'//TRIM( coupling_char )//myid_char,  &
                  FORM='UNFORMATTED', POSITION='APPEND' )
-       
+                 
+       CASE ( 27 )
+!
+!--       Binary files for virtual measurement data
+          OPEN ( 27, FILE='VIRTUAL_MEAS_BIN'//TRIM( coupling_char )//myid_char,&
+                 FORM='UNFORMATTED', POSITION='APPEND' )
 
        CASE ( 30 )
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3703)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3704)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Add last_actions for virtual measurements
 ! 
 ! Former revisions:
@@ -290,6 +290,7 @@
 
    USE virtual_measurement_mod,                                                &
-       ONLY:  vm_parin,                                                        &
-              vm_init
+       ONLY:  vm_init,                                                         &
+              vm_last_actions,                                                 &
+              vm_parin
 
    USE wind_turbine_model_mod,                                                 &
@@ -1227,5 +1228,5 @@
 SUBROUTINE module_interface_last_actions
 
-
+   IF ( virtual_measurement )  CALL vm_last_actions
    IF ( user_module_enabled )  CALL user_last_actions
 
Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 3704)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Formatting adjustments
 ! 
 ! Former revisions:
@@ -623,60 +623,64 @@
        ENDIF
 #else
-    u_ref  = u_ref_l
-    v_ref  = v_ref_l
-    IF ( humidity )       q_ref  = q_ref_l
-    IF ( .NOT. neutral )  pt_ref = pt_ref_l
+       u_ref  = u_ref_l
+       v_ref  = v_ref_l
+       IF ( humidity )       q_ref  = q_ref_l
+       IF ( .NOT. neutral )  pt_ref = pt_ref_l
 #endif
 !
-!-- Average data. Note, reference profiles up to nzt are derived from lateral
-!-- boundaries, at the model top it is derived from the top boundary. Thus,
-!-- number of input data is different from nzb:nzt compared to nzt+1. 
-!-- Derived from lateral boundaries. 
-    u_ref(nzb:nzt) = u_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx     ),      &
-                                            KIND = wp )  
-    v_ref(nzb:nzt) = v_ref(nzb:nzt) / REAL( 2.0_wp * ( ny   + nx + 1   ),      &
-                                            KIND = wp )
-    IF ( humidity )                                                            &
-       q_ref(nzb:nzt) = q_ref(nzb:nzt)   / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), &
-                                                 KIND = wp )
-    IF ( .NOT. neutral )                                                       &
-       pt_ref(nzb:nzt) = pt_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx + 1 ), &
-                                           KIND = wp )
-!
-!-- Derived from top boundary.    
-    u_ref(nzt+1) = u_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx     ), KIND = wp ) 
-    v_ref(nzt+1) = v_ref(nzt+1) / REAL( ( ny     ) * ( nx + 1 ), KIND = wp )
-    IF ( humidity )                                                            &
-       q_ref(nzt+1) = q_ref(nzt+1)   / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
-    IF ( .NOT. neutral )                                                       &
-       pt_ref(nzt+1) = pt_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx + 1 ), KIND = wp )
-!
-!-- Write onto init profiles, which are used for damping
-    u_init = u_ref
-    v_init = v_ref
-    IF ( humidity      )  q_init  = q_ref
-    IF ( .NOT. neutral )  pt_init = pt_ref
-!
-!-- Set bottom boundary condition
-    IF ( humidity      )  q_init(nzb)  = q_init(nzb+1)
-    IF ( .NOT. neutral )  pt_init(nzb) = pt_init(nzb+1)
-!
-!-- Further, adjust Rayleigh damping height in case of time-changing conditions.
-!-- Therefore, calculate boundary-layer depth first. 
-    CALL calc_zi
-    CALL adjust_sponge_layer 
-    
-!
-!-- Update geostrophic wind components from dynamic input file. 
-    DO  k = nzb+1, nzt
-       ug(k) = interpolate_in_time( nest_offl%ug(0,k), nest_offl%ug(1,k),      &
-                                    fac_dt )
-       vg(k) = interpolate_in_time( nest_offl%vg(0,k), nest_offl%vg(1,k),      &
-                                    fac_dt )
-    ENDDO
-    ug(nzt+1) = ug(nzt)
-    vg(nzt+1) = vg(nzt)
-    
-    CALL  cpu_log( log_point(58), 'offline nesting', 'stop' )
+!--    Average data. Note, reference profiles up to nzt are derived from lateral
+!--    boundaries, at the model top it is derived from the top boundary. Thus,
+!--    number of input data is different from nzb:nzt compared to nzt+1. 
+!--    Derived from lateral boundaries. 
+       u_ref(nzb:nzt) = u_ref(nzb:nzt) / REAL( 2.0_wp * ( ny + 1 + nx     ),   &
+                                               KIND = wp )  
+       v_ref(nzb:nzt) = v_ref(nzb:nzt) / REAL( 2.0_wp * ( ny   + nx + 1   ),   &
+                                               KIND = wp )
+       IF ( humidity )                                                         &
+          q_ref(nzb:nzt) = q_ref(nzb:nzt)   / REAL( 2.0_wp *                   &
+                                                          ( ny + 1 + nx + 1 ), &
+                                                    KIND = wp )
+       IF ( .NOT. neutral )                                                    &
+          pt_ref(nzb:nzt) = pt_ref(nzb:nzt) / REAL( 2.0_wp *                   &
+                                                          ( ny + 1 + nx + 1 ), &
+                                              KIND = wp )
+!
+!--    Derived from top boundary.    
+       u_ref(nzt+1) = u_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx     ), KIND = wp ) 
+       v_ref(nzt+1) = v_ref(nzt+1) / REAL( ( ny     ) * ( nx + 1 ), KIND = wp )
+       IF ( humidity )                                                         &
+          q_ref(nzt+1) = q_ref(nzt+1)   / REAL( ( ny + 1 ) * ( nx + 1 ),       &
+                                                KIND = wp )
+       IF ( .NOT. neutral )                                                    &
+          pt_ref(nzt+1) = pt_ref(nzt+1) / REAL( ( ny + 1 ) * ( nx + 1 ),       &
+                                                KIND = wp )
+!
+!--    Write onto init profiles, which are used for damping
+       u_init = u_ref
+       v_init = v_ref
+       IF ( humidity      )  q_init  = q_ref
+       IF ( .NOT. neutral )  pt_init = pt_ref
+!
+!--    Set bottom boundary condition
+       IF ( humidity      )  q_init(nzb)  = q_init(nzb+1)
+       IF ( .NOT. neutral )  pt_init(nzb) = pt_init(nzb+1)
+!
+!--    Further, adjust Rayleigh damping height in case of time-changing conditions.
+!--    Therefore, calculate boundary-layer depth first. 
+       CALL calc_zi
+       CALL adjust_sponge_layer 
+    
+!
+!--    Update geostrophic wind components from dynamic input file. 
+       DO  k = nzb+1, nzt
+          ug(k) = interpolate_in_time( nest_offl%ug(0,k), nest_offl%ug(1,k),   &
+                                       fac_dt )
+          vg(k) = interpolate_in_time( nest_offl%vg(0,k), nest_offl%vg(1,k),   &
+                                       fac_dt )
+       ENDDO
+       ug(nzt+1) = ug(nzt)
+       vg(nzt+1) = vg(nzt)
+    
+       CALL  cpu_log( log_point(58), 'offline nesting', 'stop' )
 
     END SUBROUTINE nesting_offl_bc
Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3704)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Interface for attribute input of 8-bit and 32-bit integer 
 ! 
 ! Former revisions:
@@ -777,5 +777,6 @@
     
     INTERFACE netcdf_data_input_att
-       MODULE PROCEDURE netcdf_data_input_att_int
+       MODULE PROCEDURE netcdf_data_input_att_int8
+       MODULE PROCEDURE netcdf_data_input_att_int32
        MODULE PROCEDURE netcdf_data_input_att_real
        MODULE PROCEDURE netcdf_data_input_att_string
@@ -1174,9 +1175,54 @@
 ! Description:
 ! ------------
-!> Read a global integer attribute 
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_att_int( val, search_string, id_mod,          &
-                                          input_file, global, openclose,       &
-                                          variable_name )
+!> Read a global 8-bit integer attribute 
+!------------------------------------------------------------------------------!
+    SUBROUTINE netcdf_data_input_att_int8( val, search_string, id_mod,         &
+                                           input_file, global, openclose,      &
+                                           variable_name )
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*) ::  search_string !< name of the attribue
+       
+       CHARACTER(LEN=*) ::  input_file    !< name of input file
+       CHARACTER(LEN=*) ::  openclose     !< string indicating whether NetCDF needs to be opend or closed
+       CHARACTER(LEN=*) ::  variable_name !< string indicating whether NetCDF needs to be opend or closed 
+       
+       INTEGER(iwp) ::  id_mod   !< NetCDF id of input file
+       INTEGER(KIND=1) ::  val      !< value of the attribute
+       
+       LOGICAL ::  global        !< flag indicating a global or a variable's attribute
+
+#if defined ( __netcdf )
+!
+!--    Open file in read-only mode
+       IF ( openclose == 'open' )  THEN
+          CALL open_read_file( TRIM( input_file ) // TRIM( coupling_char ), &
+                                  id_mod )
+       ENDIF
+!
+!--    Read global attribute
+       IF ( global )  THEN
+          CALL get_attribute( id_mod, search_string, val, global )
+!
+!--    Read variable attribute
+       ELSE
+          CALL get_attribute( id_mod, search_string, val, global, variable_name )
+       ENDIF
+!
+!--    Finally, close input file
+       IF ( openclose == 'close' )  CALL close_input_file( id_mod )
+#endif            
+
+    END SUBROUTINE netcdf_data_input_att_int8
+    
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read a global 32-bit integer attribute 
+!------------------------------------------------------------------------------!
+    SUBROUTINE netcdf_data_input_att_int32( val, search_string, id_mod,        &
+                                            input_file, global, openclose,     &
+                                            variable_name )
 
        IMPLICIT NONE
@@ -1214,5 +1260,5 @@
 #endif            
 
-    END SUBROUTINE netcdf_data_input_att_int
+    END SUBROUTINE netcdf_data_input_att_int32
     
 !------------------------------------------------------------------------------!
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3704)
@@ -23,5 +23,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Make variables that are sampled in virtual measurement module public 
 ! 
 ! Former revisions:
@@ -1276,5 +1276,6 @@
            idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct,                             &
            radiation_interactions, startwall, startland, endland, endwall,     &
-           skyvf, skyvft, radiation_interactions_on, average_radiation
+           skyvf, skyvft, radiation_interactions_on, average_radiation,        &
+           rad_sw_in_diff, rad_sw_in_dir
 
 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3703)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3704)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Data output for virtual measurements added
 ! 
 ! Former revisions:
@@ -632,5 +632,5 @@
                
     USE virtual_measurement_mod,                                               &
-        ONLY:  vm_sampling, vm_time_start
+        ONLY:  vm_data_output, vm_sampling, vm_time_start
 
     IMPLICIT NONE
@@ -1612,5 +1612,8 @@
 !--    Take virtual measurements
        IF ( virtual_measurement  .AND.                                         &
-            vm_time_start <= time_since_reference_point )  CALL vm_sampling
+            vm_time_start <= time_since_reference_point )  THEN
+          CALL vm_sampling
+          CALL vm_data_output
+       ENDIF
 
 !
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3704)
@@ -23,5 +23,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! make nzb_wall public, required for virtual-measurements
 ! 
 ! Former revisions:
@@ -1150,6 +1150,6 @@
 !-- Public parameters, constants and initial values
     PUBLIC usm_anthropogenic_heat, usm_material_model, usm_wall_mod,           &
-           usm_green_heat_model, building_pars,  &
-           nzt_wall, t_wall_h, t_wall_v,         &
+           usm_green_heat_model, building_pars,                                &
+           nzb_wall, nzt_wall, t_wall_h, t_wall_v,                             &
            t_window_h, t_window_v, building_type
 
@@ -7469,5 +7469,5 @@
         IMPLICIT NONE
 
-        INTEGER(iwp)                          :: i, j, k, l, m   !< running indices
+        INTEGER(iwp) :: i, j, k, l, m   !< running indices
         
         INTEGER(iwp) ::  i_off     !< offset to determine index of surface element, seen from atmospheric grid point, for x
